osgDB::ReaderWriter Class Reference

`#include <ReaderWriter>`

Inheritance diagram for osgDB::ReaderWriter:

## Classes

class | ReadResult
class | WriteResult

## Public Types

enum

Features {
FEATURE_NONE = 0 , FEATURE_READ_OBJECT = 1<<0 , FEATURE_READ_IMAGE = 1<<1 , FEATURE_READ_HEIGHT_FIELD = 1<<2 ,
FEATURE_READ_NODE = 1<<3 , FEATURE_READ_SHADER = 1<<4 , FEATURE_WRITE_OBJECT = 1<<5 , FEATURE_WRITE_IMAGE = 1<<6 ,
FEATURE_WRITE_HEIGHT_FIELD = 1<<7 , FEATURE_WRITE_NODE = 1<<8 , FEATURE_WRITE_SHADER = 1<<9 , FEATURE_READ_SCRIPT = 1<<10 ,
FEATURE_WRITE_SCRIPT = 1<<11 , FEATURE_ALL
}

| Bit mask for setting up which feature types are available for read and/or write. More...
enum | ArchiveStatus { READ , WRITE , CREATE }
typedef std::map< std::string, std::string > | FormatDescriptionMap
typedef std::list< std::string > | FeatureList
typedef osgDB::Options | Options
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ReaderWriter ()
| ReaderWriter (const ReaderWriter &rw, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~ReaderWriter ()
| META_Object (osgDB, ReaderWriter)
virtual const FormatDescriptionMap & | supportedProtocols () const
virtual const FormatDescriptionMap & | supportedExtensions () const
virtual const FormatDescriptionMap & | supportedOptions () const
virtual bool | acceptsExtension (const std::string &) const
virtual bool | acceptsProtocol (const std::string &protocol) const
virtual Features | supportedFeatures () const
virtual bool | fileExists (const std::string &filename, const Options *options) const
virtual ReadResult | openArchive (const std::string &, ArchiveStatus, unsigned int=4096, const Options *=NULL) const
virtual ReadResult | openArchive (std::istream &, const Options *=NULL) const
virtual ReadResult | readObject (const std::string &, const Options *=NULL) const
virtual ReadResult | readImage (const std::string &, const Options *=NULL) const
virtual ReadResult | readHeightField (const std::string &, const Options *=NULL) const
virtual ReadResult | readNode (const std::string &, const Options *=NULL) const
virtual ReadResult | readShader (const std::string &, const Options *=NULL) const
virtual ReadResult | readScript (const std::string &, const Options *=NULL) const
virtual WriteResult | writeObject (const osg::Object &, const std::string &, const Options *=NULL) const
virtual WriteResult | writeImage (const osg::Image &, const std::string &, const Options *=NULL) const
virtual WriteResult | writeHeightField (const osg::HeightField &, const std::string &, const Options *=NULL) const
virtual WriteResult | writeNode (const osg::Node &, const std::string &, const Options *=NULL) const
virtual WriteResult | writeShader (const osg::Shader &, const std::string &, const Options *=NULL) const
virtual WriteResult | writeScript (const osg::Script &, const std::string &, const Options *=NULL) const
virtual ReadResult | readObject (std::istream &, const Options *=NULL) const
virtual ReadResult | readImage (std::istream &, const Options *=NULL) const
virtual ReadResult | readHeightField (std::istream &, const Options *=NULL) const
virtual ReadResult | readNode (std::istream &, const Options *=NULL) const
virtual ReadResult | readShader (std::istream &, const Options *=NULL) const
virtual ReadResult | readScript (std::istream &, const Options *=NULL) const
virtual WriteResult | writeObject (const osg::Object &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeImage (const osg::Image &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeHeightField (const osg::HeightField &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeNode (const osg::Node &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeShader (const osg::Shader &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeScript (const osg::Script &, std::ostream &, const Options *=NULL) const
void | supportsProtocol (const std::string &fmt, const std::string &description)
void | supportsExtension (const std::string &ext, const std::string &description)
void | supportsOption (const std::string &opt, const std::string &description)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static FeatureList | featureAsString (Features feature)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Attributes

FormatDescriptionMap | _supportedProtocols
FormatDescriptionMap | _supportedExtensions
FormatDescriptionMap | _supportedOptions
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Detailed Description

Pure virtual base class for reading and writing of non native formats.

## Member Typedef Documentation

## FeatureList

typedef std::list<std::string> osgDB::ReaderWriter::FeatureList

## FormatDescriptionMap

typedef std::map<std::string, std::string> osgDB::ReaderWriter::FormatDescriptionMap

## Options

typedef osgDB::Options osgDB::ReaderWriter::Options

## Member Enumeration Documentation

## ArchiveStatus

enum osgDB::ReaderWriter::ArchiveStatus

Enumerator
READ |
WRITE |
CREATE |

## Features

enum osgDB::ReaderWriter::Features

Bit mask for setting up which feature types are available for read and/or write.

Enumerator
FEATURE_NONE |
FEATURE_READ_OBJECT |
FEATURE_READ_IMAGE |
FEATURE_READ_HEIGHT_FIELD |
FEATURE_READ_NODE |
FEATURE_READ_SHADER |
FEATURE_WRITE_OBJECT |
FEATURE_WRITE_IMAGE |
FEATURE_WRITE_HEIGHT_FIELD |
FEATURE_WRITE_NODE |
FEATURE_WRITE_SHADER |
FEATURE_READ_SCRIPT |
FEATURE_WRITE_SCRIPT |
FEATURE_ALL |

## Constructor & Destructor Documentation

## ReaderWriter() [1/2]

osgDB::ReaderWriter::ReaderWriter | ( |  | ) |

inline

References osg::Object::Object().

Referenced by META_Object(), and ReaderWriter().

## ReaderWriter() [2/2]

osgDB::ReaderWriter::ReaderWriter | ( | const ReaderWriter & | rw,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References osg::Object::Object(), ReaderWriter(), and osg::CopyOp::SHALLOW_COPY.

## ~ReaderWriter()

virtual osgDB::ReaderWriter::~ReaderWriter | ( |  | ) |

virtual

## Member Function Documentation

## acceptsExtension()

virtual bool osgDB::ReaderWriter::acceptsExtension | ( | const std::string & |  | ) | const

virtual

Return true if ReaderWriter accepts specified file extension.

Reimplemented in osgDB::Archive.

## acceptsProtocol()

virtual bool osgDB::ReaderWriter::acceptsProtocol | ( | const std::string & | protocol | ) | const

virtual

## featureAsString()

FeatureList osgDB::ReaderWriter::featureAsString | ( | Features | feature | ) |

static

Return feature as string

## fileExists()

virtual bool osgDB::ReaderWriter::fileExists | ( | const std::string & | filename,
|  | const Options * | options ) const

virtual

Determine if a file exists, normally the default implementation will be appropriate for local file access but with plugins like the libcurl based one it will return true if the file is accessible at the server.

## META_Object()

osgDB::ReaderWriter::META_Object | ( | osgDB | ,
|  | ReaderWriter | )

References ReaderWriter().

## openArchive() [1/2]

virtual ReadResult osgDB::ReaderWriter::openArchive | ( | const std::string & | ,
|  | ArchiveStatus | ,
|  | unsigned int | = 4096,
|  | const Options * | = NULL ) const

inline virtual

Open an archive for reading, writing, or to create an empty archive for writing to.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## openArchive() [2/2]

virtual ReadResult osgDB::ReaderWriter::openArchive | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

Open an archive for reading.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readHeightField() [1/2]

virtual ReadResult osgDB::ReaderWriter::readHeightField | ( | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readHeightField() [2/2]

virtual ReadResult osgDB::ReaderWriter::readHeightField | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readImage() [1/2]

virtual ReadResult osgDB::ReaderWriter::readImage | ( | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readImage() [2/2]

virtual ReadResult osgDB::ReaderWriter::readImage | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readNode() [1/2]

virtual ReadResult osgDB::ReaderWriter::readNode | ( | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readNode() [2/2]

virtual ReadResult osgDB::ReaderWriter::readNode | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readObject() [1/2]

virtual ReadResult osgDB::ReaderWriter::readObject | ( | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readObject() [2/2]

virtual ReadResult osgDB::ReaderWriter::readObject | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readScript() [1/2]

virtual ReadResult osgDB::ReaderWriter::readScript | ( | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readScript() [2/2]

virtual ReadResult osgDB::ReaderWriter::readScript | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readShader() [1/2]

virtual ReadResult osgDB::ReaderWriter::readShader | ( | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## readShader() [2/2]

virtual ReadResult osgDB::ReaderWriter::readShader | ( | std::istream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::ReadResult::NOT_IMPLEMENTED, and NULL.

## supportedExtensions()

virtual const FormatDescriptionMap & osgDB::ReaderWriter::supportedExtensions | ( |  | ) | const

inline virtual

Return which list of file extensions supported by ReaderWriter.

References _supportedExtensions.

## supportedFeatures()

virtual Features osgDB::ReaderWriter::supportedFeatures | ( |  | ) | const

virtual

Return available features

## supportedOptions()

virtual const FormatDescriptionMap & osgDB::ReaderWriter::supportedOptions | ( |  | ) | const

inline virtual

Return which list of file extensions supported by ReaderWriter.

References _supportedOptions.

## supportedProtocols()

virtual const FormatDescriptionMap & osgDB::ReaderWriter::supportedProtocols | ( |  | ) | const

inline virtual

Return which protocols are supported by ReaderWriter.

References _supportedProtocols.

## supportsExtension()

void osgDB::ReaderWriter::supportsExtension | ( | const std::string & | ext,
|  | const std::string & | description )

Specify ext string as a supported file extension. Please note, this method should usually only be used internally by subclasses of ReaderWriter. Only in special cases will a ReaderWriter implementation be able to handle a file extension that it wasn't originally designed for. To know whether it's safe to inject a new file extension into an existing ReaderWriter you will need to review the the source code and dependencies of that ReaderWriter.

## supportsOption()

void osgDB::ReaderWriter::supportsOption | ( | const std::string & | opt,
|  | const std::string & | description )

Specify option string as a supported option string. Please note, this should usually only be used internally by subclasses of ReaderWriter.

## supportsProtocol()

void osgDB::ReaderWriter::supportsProtocol | ( | const std::string & | fmt,
|  | const std::string & | description )

Specify fmt string as a supported protocol. Please note, this method should usually only be used internally by subclasses of ReaderWriter, Only in special cases will a ReaderWriter implementation be able to handle a protocol format that it wasn't originally designed for. To know whether it's safe to inject a new protocol format into an existing ReaderWriter you will need to review the source code and dependencies of that ReaderWriter.

## writeHeightField() [1/2]

virtual WriteResult osgDB::ReaderWriter::writeHeightField | ( | const osg::HeightField & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeHeightField() [2/2]

virtual WriteResult osgDB::ReaderWriter::writeHeightField | ( | const osg::HeightField & | ,
|  | std::ostream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeImage() [1/2]

virtual WriteResult osgDB::ReaderWriter::writeImage | ( | const osg::Image & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeImage() [2/2]

virtual WriteResult osgDB::ReaderWriter::writeImage | ( | const osg::Image & | ,
|  | std::ostream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeNode() [1/2]

virtual WriteResult osgDB::ReaderWriter::writeNode | ( | const osg::Node & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeNode() [2/2]

virtual WriteResult osgDB::ReaderWriter::writeNode | ( | const osg::Node & | ,
|  | std::ostream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeObject() [1/2]

virtual WriteResult osgDB::ReaderWriter::writeObject | ( | const osg::Object & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeObject() [2/2]

virtual WriteResult osgDB::ReaderWriter::writeObject | ( | const osg::Object & | ,
|  | std::ostream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeScript() [1/2]

virtual WriteResult osgDB::ReaderWriter::writeScript | ( | const osg::Script & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeScript() [2/2]

virtual WriteResult osgDB::ReaderWriter::writeScript | ( | const osg::Script & | ,
|  | std::ostream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeShader() [1/2]

virtual WriteResult osgDB::ReaderWriter::writeShader | ( | const osg::Shader & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

inline virtual

Reimplemented in osgDB::Archive.

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## writeShader() [2/2]

virtual WriteResult osgDB::ReaderWriter::writeShader | ( | const osg::Shader & | ,
|  | std::ostream & | ,
|  | const Options * | = NULL ) const

inline virtual

References osgDB::ReaderWriter::WriteResult::NOT_IMPLEMENTED, and NULL.

## Member Data Documentation

## _supportedExtensions

FormatDescriptionMap osgDB::ReaderWriter::_supportedExtensions

protected

Referenced by supportedExtensions().

## _supportedOptions

FormatDescriptionMap osgDB::ReaderWriter::_supportedOptions

protected

Referenced by supportedOptions().

## _supportedProtocols

FormatDescriptionMap osgDB::ReaderWriter::_supportedProtocols

protected

Referenced by supportedProtocols().

The documentation for this class was generated from the following file:

- ReaderWriter